'Batch program to rewrite MagicTraders txt price files fixing
' set abbrevs/names to match MWS sets for correct pricebase data import
'Also creates lists with High price as default
'Cards fixed and total printed to screen
'Works with the comma-delimited files from
' magictraders.com/pricelists/. Does not change formatting
'*Edit OPEN path/filenames as needed

CLS
OPEN "C:\MAGIC\MTPL.TXT" FOR INPUT AS #1
OPEN "C:\MAGIC\MTPLFIX.TXT" FOR OUTPUT AS #2
OPEN "C:\MAGIC\MTPLHIGH.TXT" FOR OUTPUT AS #3
GOSUB FIXSUB
CLOSE #1
CLOSE #2
CLOSE #3
PRINT "COMPLETED NONFOIL"
PRINT
nftot = total: total = 0

OPEN "C:\MAGIC\MTPL_F.TXT" FOR INPUT AS #1
OPEN "C:\MAGIC\MTPLFOIL.TXT" FOR OUTPUT AS #2
OPEN "C:\MAGIC\MTPLFHI.TXT" FOR OUTPUT AS #3
GOSUB FIXSUB
CLOSE #1
CLOSE #2
CLOSE #3
PRINT "COMPLETED FOIL"

PRINT: PRINT "TOTAL NonFoil: "; nftot; "  TOTAL Foil: "; total
PRINT "GRAND TOTAL FIXED: "; nftot + total
END

'*************************************

FIXSUB:
PRINT "FINDING.."
PRINT
LINE INPUT #1, X$
PRINT #2, X$
PRINT #3, X$
LINE INPUT #1, X$
PRINT #2, X$
PRINT #3, X$
LINE INPUT #1, X$
DO

    'Get the card name by itself
    NAM$ = ""
    A = 0
    DO
        A = A + 1
        NAM$ = NAM$ + MID$(X$, A, 1)
    LOOP UNTIL RIGHT$(NAM$, 2) = "  " 'Always at least 2 spc at end
    NAM$ = RTRIM$(NAM$)
    NAM$ = LEFT$(NAM$, LEN(NAM$) - 1) 'Comma

    FIXED = 0
    'Run name change checks
    SELECT CASE NAM$
        CASE "Ach! Hans, Run!"
            NAM$ = CHR$(34) + NAM$ + CHR$(34)
            FIXED = 1
        CASE "Erase (UL)"
            NAM$ = "Erase"
            FIXED = 1
        CASE "Erase (UNH)"
            NAM$ = "Erase (Not the Urza's Legacy One)"
            FIXED = 1
        CASE "Balance (DCI)"
            NAM$ = "Balance (JGC)"
            FIXED = 1
        CASE "No Name"
            NAM$ = "_____"
            FIXED = 1
        CASE "Question Elemental?"
            NAM$ = LEFT$(NAM$, LEN(NAM$) - 1)
            FIXED = 1
        CASE "Tahngarth, Talruum Hero (Alt. Art)"
            NAM$ = "Tahngarth, Talruum Hero (2)"
            FIXED = 1
        CASE "Alladin's Lamp"
            NAM$ = "Aladdin's Lamp"
            FIXED = 1
        CASE "Alladin's Ring"
            NAM$ = "Aladdin's Ring"
            FIXED = 1
    END SELECT

    IF LEFT$(NAM$, 12) = "Longest Card" THEN
        NAM$ = "Our Market Research Shows That Players Like Really Long Card Names So We Made th"
        FIXED = 1
    END IF
    IF LEFT$(NAM$, 5) = "Mine," THEN
        NAM$ = "Mine Mine Mine!" 'put commas back in edit pricebase
        FIXED = 1 'this is the card that causes Skipped 1
    END IF

    'Tokens
    TKLOC = INSTR(2, NAM$, " Token")
    IF TKLOC THEN
        IF RIGHT$(NAM$, 1) = ")" THEN 'strip Token, keep (TK)
            NAM$ = LEFT$(NAM$, TKLOC) + RIGHT$(NAM$, 4)
        ELSE
            NAM$ = LEFT$(NAM$, TKLOC - 1)
        END IF
        FIXED = 1
    END IF

    'Sets
    IF FIXED = 0 AND RIGHT$(NAM$, 1) = ")" THEN
        S$ = MID$(NAM$, INSTR(2, NAM$, "("))
        FIXED = 1
        SELECT CASE S$
            CASE "(LE)"
                S$ = "(LG)"
            CASE "(UZ)"
                S$ = "(US)"
            CASE "(ST)"
                S$ = "(SH)"
            CASE "(ST1)"
                S$ = "(ST)"
            CASE "(ST2)"
                S$ = "(S00)"
            CASE "(PR)"
                S$ = "(PY)"
            CASE "(BK)"
                S$ = "(MPR)"
                SN$ = LEFT$(NAM$, LEN(NAM$) - 5)
                IF SN$ = "Forest" OR SN$ = "Island" OR SN$ = "Mountain" OR SN$ = "Plains" OR SN$ = "Swamp" THEN S$ = "(ARE)"
                IF SN$ = "Arena" OR SN$ = "Counterspell" OR SN$ = "Incinerate" OR SN$ = "Giant Badger" THEN S$ = "(PR)"
            CASE "(TOR)"
                S$ = "(TO)"
            CASE "(JUD)"
                S$ = "(JU)"
            CASE "(ONS)"
                S$ = "(ON)"
            CASE "(LGN)"
                S$ = "(LE)"
            CASE "(SCG)"
                S$ = "(SC)"
            CASE "(DST)"
                S$ = "(DS)"
            CASE "(MRD)"
                S$ = "(MR)"
            CASE "(5DN)"
                S$ = "(FD)"
            CASE "(DCI)"
                S$ = "(FNM)"
            CASE "(JSS)"
                S$ = "(JUN)"
            CASE "(AR)"
                S$ = "(ARE)"
            CASE "(GPT)"
                S$ = "(GP)"
            CASE "(CSP)"
                S$ = "(CS)"
            CASE "(UL)"
                S$ = "(UY)" 'You have to manually edit these back to UL in pricebase
            CASE ELSE
                FIXED = 0
        END SELECT
        IF FIXED = 1 THEN
            NAM$ = LEFT$(NAM$, INSTR(2, NAM$, "(") - 1) + S$
        END IF
    END IF

    'If a change was made, write it
    IF FIXED = 1 THEN
        X$ = NAM$ + "," + MID$(X$, A - 1)
        PRINT NAM$; " ";
        total = total + 1
    END IF
    PRINT #2, X$

    'Write High in Price column. A is pos after the end of name
    PCOMMA = INSTR(A + 1, X$, ",") 'find price comma pos
    COMMA = INSTR(PCOMMA + 1, X$, ",")
    COMMA = INSTR(COMMA + 1, X$, ",")
    HIGH$ = LTRIM$(MID$(X$, COMMA + 1, INSTR(COMMA + 2, X$, ",") - COMMA - 1))
    FOUND = 0
    DO
        A = A + 1
        IF ASC(MID$(X$, A, 1)) <> 32 THEN
            FOUND = 1
        END IF
    LOOP UNTIL FOUND = 1
    X$ = LEFT$(X$, A - 1) + HIGH$ + MID$(X$, PCOMMA)
    PRINT #3, X$

    LINE INPUT #1, X$
LOOP UNTIL EOF(1)

PRINT #2, X$ 'Writes the total line
PRINT #3, X$
PRINT
PRINT
RETURN

